package com.agilecontrol.nea.core.control.web.binhandler;

import com.agilecontrol.nea.core.control.web.UserWebImpl;
import com.agilecontrol.nea.core.control.web.WebUtils;
import com.agilecontrol.nea.core.control.web.binhandler.BinaryHandler;
import com.agilecontrol.nea.core.report.ReportUtils;
import com.agilecontrol.nea.core.util.ConfigValues;
import com.agilecontrol.nea.util.Tools;
import java.io.File;
import java.io.FileInputStream;
import java.io.PrintWriter;
import javax.servlet.ServletContext;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class GetFile implements BinaryHandler {

   private static final Logger log = LoggerFactory.getLogger(GetFile.class);
   public static final String CONTENT_TYPE = "text/html; charset=UTF-8";
   public static final String PLAIN_CONTENT_TYPE = "text/plain; charset=GBK";
   public static final String DOWNLOAD_TYPE = "application/octetstream; charset=GBK";
   public static final String[] TEXT_TYPE = new String[]{"html", "htm", "csv", "txt", "log", "sql", "xml"};
   public static final String[] EXT = new String[]{"xls", "doc", "pdf", "zip", "db", "xlsx", "docx", "ppt", "pptx", "png", "jpg", "gif", "bmp", "html", "xml", "htm", "jpeg", "mov", "mp4", "mp3", "avi"};
   public static final String[] EXT_CONTENT_TYPE = new String[]{"application/vnd.ms-excel", "application/vnd.ms-word", "application/pdf", "application/zip", "application/db", "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet", "application/msword", "application/vnd.ms-powerpoint", "application/vnd.openxmlformats-officedocument.presentationml.presentation", "image/png", "image/jpg", "image/gif", "image/gif", "image/bmp", "text/html", "text/xml", "text/html", "image/jpg", "video/avi", "video/mp4v-es", "audio/mp3", "video/avi"};


   private int getFileType(String fileName) {
      String ext = fileName.substring(fileName.lastIndexOf(".") + 1).toLowerCase();

      for(int i = 0; i < TEXT_TYPE.length; ++i) {
         if(ext.equalsIgnoreCase(TEXT_TYPE[i])) {
            return ext.contains("htm")?0:1;
         }
      }

      return -1;
   }

   public void process(HttpServletRequest request, HttpServletResponse response) throws Exception {
      String filePath = request.getParameter("filename");
      boolean deleteFile = Tools.getYesNo(request.getParameter("del"), false);
      String cd = request.getParameter("cd");
      if(!"attachment".equalsIgnoreCase(cd)) {
         cd = "inline";
      }

      if(filePath == null) {
         String isShow = request.getPathInfo();
         int out = isShow.indexOf(47, 1);
         if(out > 0) {
            filePath = isShow.substring(out + 1);
         }
      }

      boolean var15 = Tools.getYesNo(request.getParameter("show"), true);
      if(filePath != null && !filePath.trim().equals("")) {
         filePath = filePath.trim();
         ReportUtils var16 = new ReportUtils(request);
         UserWebImpl userWeb = var16.getUser();
         if((filePath.contains("..") || filePath.contains("/") || filePath.contains("\\")) && (!ConfigValues.get("portal.skip_root_download", false) || !userWeb.isAdmin())) {
            throw new IllegalArgumentException("Illegal file path ");
         }

         File file = new File(var16.getExportRootPath() + File.separator + var16.getUser().getClientDomain() + File.separator + var16.getUser().getUserId() + File.separator + filePath);
         if(file.exists() && file.isFile()) {
            log.debug("Downloading " + file.getAbsolutePath());
            int fileType = this.getFileType(file.getName());
            int bInt;
            if(fileType == 0) {
               response.setContentType("text/html; charset=UTF-8");
               response.setHeader("Content-Disposition", cd + ";" + WebUtils.getContentDispositionFileName(filePath, request));
            } else if(fileType == 1) {
               response.setContentType("text/plain; charset=GBK");
               response.setHeader("Content-Disposition", cd + ";" + WebUtils.getContentDispositionFileName(filePath, request));
            } else {
               boolean is = false;
               if(var15) {
                  String os = null;
                  int b = file.getName().lastIndexOf(46);
                  if(b > 0) {
                     os = file.getName().substring(b + 1);
                  }

                  if(os != null) {
                     for(bInt = 0; bInt < EXT.length; ++bInt) {
                        if(EXT[bInt].equals(os)) {
                           response.setContentType(EXT_CONTENT_TYPE[bInt]);
                           response.setHeader("Content-Disposition", cd + ";" + WebUtils.getContentDispositionFileName(filePath, request));
                           is = true;
                           break;
                        }
                     }
                  }
               }

               if(!is) {
                  response.setContentType("application/octetstream; charset=GBK");
                  response.setHeader("Content-Disposition", cd + ";" + WebUtils.getContentDispositionFileName(filePath, request));
               }
            }

            FileInputStream var18 = new FileInputStream(file);
            ServletOutputStream var19 = response.getOutputStream();
            byte[] var20 = new byte[8192];

            while((bInt = var18.read(var20, 0, var20.length)) != -1) {
               var19.write(var20, 0, bInt);
            }

            var19.close();
            var18.close();
            log.debug("Downloaded " + file.getAbsolutePath());
            if(deleteFile) {
               ;
            }

            return;
         }

         log.warn("Could not load file:" + file.getAbsolutePath());
      }

      response.setContentType("text/html; charset=UTF-8");
      PrintWriter var17 = response.getWriter();
      var17.println("<html>");
      var17.println("<head><title>GetFile</title></head>");
      var17.println("<body>");
      var17.println("<p>文件不存在,或者文件不可读，或者没有指定文件名</p>");
      var17.println("</body></html>");
   }

   public void init(ServletContext context) {
   }

}
